/*
 * #%L
 * ELK Reasoner
 * 
 * $Id$
 * $HeadURL$
 * %%
 * Copyright (C) 2011 - 2012 Department of Computer Science, University of Oxford
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
package org.semanticweb.elk.reasoner.saturation.rulesystem;

import java.lang.reflect.Method;

/**
 * A simple exception to report problems when registering inference methods in
 * InferenceRuleManager.
 * 
 * @author Markus Kroetzsch
 * 
 */
public class IllegalInferenceMethodException extends Exception {

	/**
	 * The version identifier for this Serializable class. Increment only if the
	 * <i>serialized</i> form of the class changes.
	 */
	private static final long serialVersionUID = 1L;

	public IllegalInferenceMethodException(String methodName, String message) {
		super("Cannot use the rule method '" + methodName + "'.\n" + message);
	}
	
	public IllegalInferenceMethodException(Method inferenceMethod, String message) {
		super("Cannot use the inference method '" + inferenceMethod + "'.\n" + message);
	}
	
}
